#include <PSX/System/IOPorts/SPU_IO.hpp>

namespace SPU {
    static void clear_voice(Voice& voice) {
        io_class__volatile_assign(voice.volumeLeft,  SweepVolume());
        io_class__volatile_assign(voice.volumeRight, SweepVolume());

        io_class__volatile_assign(voice.sampleRate,    SampleRate::from_HZ(0.0));
        io_class__volatile_assign(voice.adsr,          ADSR());
        io_class__volatile_assign(voice.currentVolume, SweepVolume());

        voice.adr       = 0x200;
        voice.repeatAdr = 0x200;
    }

    void setup() {
        static constexpr auto StartVol = SweepVolume().set_volume_mode().set_volume_percent(50.0);

        io_class__volatile_assign(MainVolume::Left,  StartVol);
        io_class__volatile_assign(MainVolume::Right, StartVol);

        for(auto& voice : Voice::Channel) {
            clear_voice(voice);
        }
    }
}